#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-05-05; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.live.builder.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.live.builder
# SPDX-Security-Contact: security@coresecret.eu

guard_sourcing

#######################################
# Trap function to be called on 'EXIT'.
# Globals:
#   VAR_EARLY_DEBUG
# Arguments:
#   $1: $?
#######################################
trap_on_exit() {
  trap - EXIT
  declare -r var_trap_on_exit_code="$1"
  if (( var_trap_on_exit_code == 0 )); then
    if "${VAR_EARLY_DEBUG}"; then dump_user_vars; fi
    clean_up "${var_trap_on_exit_code}"
    print_scr_exit "${var_trap_on_exit_code}"
    exit "${var_trap_on_exit_code}"
  else
    exit "${var_trap_on_exit_code}"
  fi
}

#######################################
# Print Success Message for Trap on 'EXIT' on 'stdout'.
# Globals:
#   LOG_DEBUG
#   LOG_VAR
#   SECONDS
#   VAR_EARLY_DEBUG
#   VAR_HANDLER_BUILD_DIR
#   VAR_SCRIPT_SUCCESS
# Arguments:
#   $1: ${var_trap_on_exit_code} of trap_on_exit()
#######################################
print_scr_exit() {
  declare -r var_print_scr_exit_code="$1"
  if (( var_print_scr_exit_code == 0 )); then
    if [[ "${VAR_SCRIPT_SUCCESS}" == "true" ]]; then
      printf "\n"
      printf "\e[92m✅ CISS.debian.live.builder Script successful. \e[0m\n"
      printf "\e[92m✅ Aide Initial DB at     : %s \e[0m\n" "${VAR_HANDLER_BUILD_DIR}/.integrity/"
      printf "\e[92m✅ Exited with Status     : %s \e[0m\n" "${var_print_scr_exit_code}"
      printf "\n"
      if [[ "${VAR_EARLY_DEBUG}" == "true" ]]; then
        printf "\e[92m✅ Script Runtime         : %s \e[0m\n" "${SECONDS}"
        printf "\e[92m✅ Vars Dump saved at     : %s \e[0m\n" "${LOG_VAR}"
        printf "\e[92m✅ Debug Log saved at     : %s \e[0m\n" "${LOG_DEBUG}"
        printf "\e[92m✅ batcat --pager='less -r' %s \e[0m\n" "${LOG_DEBUG}"
        printf "\n"
      fi
      printf "\e[95m💷 Please consider donating to my work at: \e[0m\n"
      printf "\e[95m🔗 https://coresecret.eu/spenden/          \e[0m\n"
      printf "\n"
    fi
  fi
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
